//
// ApiMairieAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



open class ApiMairieAPI: APIBase {
    /**
     Récupère toutes les communes
     
     - parameter codePostal: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiMairieGetCommunesGet(codePostal: String, completion: @escaping ((_ data: [Commune]?,_ error: Error?) -> Void)) {
        apiMairieGetCommunesGetWithRequestBuilder(codePostal: codePostal).execute { (response, error) -> Void in
            completion(response?.body, error);
        }
    }


    /**
     Récupère toutes les communes
     - GET /apiMairie/getCommunes
     - Permet de récupérer l'ensemble des communes de la mairie
     - BASIC:
       - type: basic
       - name: Basic
     - examples: [{contentType=application/json, example=[ {
  "codePostaux" : [ "aeiou" ],
  "latitude" : "aeiou",
  "codeInsee" : "aeiou",
  "nom" : "aeiou",
  "longitude" : "aeiou"
} ]}]
     
     - parameter codePostal: (query)  

     - returns: RequestBuilder<[Commune]> 
     */
    open class func apiMairieGetCommunesGetWithRequestBuilder(codePostal: String) -> RequestBuilder<[Commune]> {
        let path = "/apiMairie/getCommunes"
        let URLString = MyVillageAPIAPI.basePath + path

        let nillableParameters: [String:Any?] = [
            "codePostal": codePostal
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Commune]>.Type = MyVillageAPIAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Récupère tous les quartiers
     
     - parameter codeInsee: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiMairieGetQuartiersGet(codeInsee: String, completion: @escaping ((_ data: [Quartier]?,_ error: Error?) -> Void)) {
        apiMairieGetQuartiersGetWithRequestBuilder(codeInsee: codeInsee).execute { (response, error) -> Void in
            completion(response?.body, error);
        }
    }


    /**
     Récupère tous les quartiers
     - GET /apiMairie/getQuartiers
     - Permet de recuperer l'ensemble des quartiers de la mairie
     - BASIC:
       - type: basic
       - name: Basic
     - examples: [{contentType=application/json, example=[ {
  "alertes" : [ {
    "foyerEmetteur" : {
      "identifiantUnique" : "aeiou",
      "abonnementQuartier" : [ "" ],
      "utilisateurs" : [ {
        "id" : "aeiou",
        "nom" : "aeiou",
        "prenom" : "aeiou"
      } ],
      "lastUpdated" : "2000-01-23T04:56:07.000+00:00",
      "dateCreated" : "2000-01-23T04:56:07.000+00:00",
      "immeuble" : {
        "latitude" : "aeiou",
        "adresse" : "aeiou",
        "id" : "",
        "longitude" : "aeiou"
      },
      "id" : "aeiou",
      "nom" : "aeiou",
      "numeroTelephone" : "aeiou",
      "uuid" : [ "aeiou" ]
    },
    "dateCreated" : "2000-01-23T04:56:07.000+00:00",
    "etatCourant" : "aeiou",
    "typeAlerte" : "aeiou",
    "evenements" : [ {
      "dateCreated" : "2000-01-23T04:56:07.000+00:00",
      "typeEvenement" : "aeiou",
      "nomFoyerEmetteur" : "aeiou"
    } ],
    "id" : "aeiou",
    "foyerImpacte" : ""
  } ],
  "marie" : "aeiou",
  "id" : "aeiou",
  "nom" : "aeiou",
  "tous" : true
} ]}]
     
     - parameter codeInsee: (query)  

     - returns: RequestBuilder<[Quartier]> 
     */
    open class func apiMairieGetQuartiersGetWithRequestBuilder(codeInsee: String) -> RequestBuilder<[Quartier]> {
        let path = "/apiMairie/getQuartiers"
        let URLString = MyVillageAPIAPI.basePath + path

        let nillableParameters: [String:Any?] = [
            "codeInsee": codeInsee
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Quartier]>.Type = MyVillageAPIAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
